diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageParser.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageParser.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageParser.java	2017-09-27 02:07:48.943736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageParser.java	2017-09-21 16:08:36.659826000 +0900
@@ -25,8 +25,13 @@
 import static android.content.pm.PackageManager.INSTALL_PARSE_FAILED_NO_CERTIFICATES;
 import static android.content.pm.PackageManager.INSTALL_PARSE_FAILED_UNEXPECTED_EXCEPTION;
 
+import android.annotation.NonNull;
 import android.app.ActivityManager;
+import android.app.ResourcesManager;
+import android.app.SearchManager;
 import android.content.ComponentName;
+import android.content.Context;
+import android.content.ContextWrapper;
 import android.content.Intent;
 import android.content.IntentFilter;
 import android.content.res.AssetManager;
@@ -39,7 +44,11 @@
 import android.os.Environment;
 import android.os.FileUtils;
 import android.os.PatternMatcher;
+import android.os.RemoteException;
+import android.os.ServiceManager;
 import android.os.UserHandle;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteServiceManager;
 import android.text.TextUtils;
 import android.util.ArrayMap;
 import android.util.ArraySet;
@@ -50,6 +59,10 @@
 import android.util.Pair;
 import android.util.Slog;
 import android.util.TypedValue;
+import android.view.WindowManager;
+/*
+import com.android.bitmap.R;
+*/
 
 import com.android.internal.R;
 import com.android.internal.util.ArrayUtils;
@@ -57,13 +70,29 @@
 
 import libcore.io.IoUtils;
 
+//import com.android.internal.apache.commons.io.input.ReversedLinesFileReader;
+//import org.apache.commons.io.input.ReversedLinesFileReader;
 import org.xmlpull.v1.XmlPullParser;
 import org.xmlpull.v1.XmlPullParserException;
 
+import java.io.BufferedInputStream;
+import java.io.BufferedOutputStream;
+import java.io.BufferedReader;
+import java.io.BufferedWriter;
 import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
+import java.io.FileOutputStream;
+import java.io.FileReader;
+import java.io.FileWriter;
+import java.io.FilenameFilter;
 import java.io.IOException;
 import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.io.OutputStream;
 import java.io.PrintWriter;
+import java.io.RandomAccessFile;
+import java.lang.reflect.Field;
 import java.security.GeneralSecurityException;
 import java.security.KeyFactory;
 import java.security.NoSuchAlgorithmException;
@@ -77,12 +106,17 @@
 import java.util.Arrays;
 import java.util.Collections;
 import java.util.Comparator;
+import java.util.HashMap;
+import java.util.HashSet;
 import java.util.Iterator;
 import java.util.List;
+import java.util.Map;
 import java.util.Set;
+import java.util.TreeMap;
 import java.util.concurrent.atomic.AtomicReference;
 import java.util.jar.StrictJarFile;
 import java.util.zip.ZipEntry;
+import java.util.zip.ZipInputStream;
 
 /**
  * Parser for package files (APKs) on disk. This supports apps packaged either
@@ -103,6 +137,24 @@
  * @hide
  */
 public class PackageParser {
+    //reviseapp
+    private boolean IS_REVISE_APP = false;
+    private String CURRENT_REVISE_APP = "";
+
+    //collaboroid
+    private boolean IS_AGENT_APP = false;
+    private AssetManager AGENT_AM;
+    private String CURRENT_AGENT_APP = "";
+    private String CURRENT_AGENT_PACKAGE = "";
+    private String CURRENT_AGENT_ACTIVITY = "";
+    // -> com/android/test
+    private Resources AGENT_RES;
+    HashMap<String, String[]> smali$FileList = new HashMap<>();
+
+    private HashMap<String, HashMap<String, List<String>>> ActivityTable = new HashMap<>();
+    //1.appName     2.packageName + MainActivityName ------- related activity
+    private HashMap<String, HashMap<String, List<String>>> ResourceTable = new HashMap<>();
+    //1.appName     2.packageName + ActivityName -------- related ResourceFile
     private static final boolean DEBUG_JAR = false;
     private static final boolean DEBUG_PARSER = false;
     private static final boolean DEBUG_BACKUP = false;
@@ -121,7 +173,7 @@
         public final String name;
         public final int sdkVersion;
         public final int fileVersion;
-        
+
         public NewPermissionInfo(String name, int sdkVersion, int fileVersion) {
             this.name = name;
             this.sdkVersion = sdkVersion;
@@ -152,12 +204,12 @@
      * @hide
      */
     public static final PackageParser.NewPermissionInfo NEW_PERMISSIONS[] =
-        new PackageParser.NewPermissionInfo[] {
-            new PackageParser.NewPermissionInfo(android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
-                    android.os.Build.VERSION_CODES.DONUT, 0),
-            new PackageParser.NewPermissionInfo(android.Manifest.permission.READ_PHONE_STATE,
-                    android.os.Build.VERSION_CODES.DONUT, 0)
-    };
+            new PackageParser.NewPermissionInfo[] {
+                    new PackageParser.NewPermissionInfo(android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
+                            android.os.Build.VERSION_CODES.DONUT, 0),
+                    new PackageParser.NewPermissionInfo(android.Manifest.permission.READ_PHONE_STATE,
+                            android.os.Build.VERSION_CODES.DONUT, 0)
+            };
 
     /**
      * List of permissions that have been split into more granular or dependent
@@ -165,21 +217,21 @@
      * @hide
      */
     public static final PackageParser.SplitPermissionInfo SPLIT_PERMISSIONS[] =
-        new PackageParser.SplitPermissionInfo[] {
-            // READ_EXTERNAL_STORAGE is always required when an app requests
-            // WRITE_EXTERNAL_STORAGE, because we can't have an app that has
-            // write access without read access.  The hack here with the target
-            // target SDK version ensures that this grant is always done.
-            new PackageParser.SplitPermissionInfo(android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
-                    new String[] { android.Manifest.permission.READ_EXTERNAL_STORAGE },
-                    android.os.Build.VERSION_CODES.CUR_DEVELOPMENT+1),
-            new PackageParser.SplitPermissionInfo(android.Manifest.permission.READ_CONTACTS,
-                    new String[] { android.Manifest.permission.READ_CALL_LOG },
-                    android.os.Build.VERSION_CODES.JELLY_BEAN),
-            new PackageParser.SplitPermissionInfo(android.Manifest.permission.WRITE_CONTACTS,
-                    new String[] { android.Manifest.permission.WRITE_CALL_LOG },
-                    android.os.Build.VERSION_CODES.JELLY_BEAN)
-    };
+            new PackageParser.SplitPermissionInfo[] {
+                    // READ_EXTERNAL_STORAGE is always required when an app requests
+                    // WRITE_EXTERNAL_STORAGE, because we can't have an app that has
+                    // write access without read access.  The hack here with the target
+                    // target SDK version ensures that this grant is always done.
+                    new PackageParser.SplitPermissionInfo(android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
+                            new String[] { android.Manifest.permission.READ_EXTERNAL_STORAGE },
+                            android.os.Build.VERSION_CODES.CUR_DEVELOPMENT+1),
+                    new PackageParser.SplitPermissionInfo(android.Manifest.permission.READ_CONTACTS,
+                            new String[] { android.Manifest.permission.READ_CALL_LOG },
+                            android.os.Build.VERSION_CODES.JELLY_BEAN),
+                    new PackageParser.SplitPermissionInfo(android.Manifest.permission.WRITE_CONTACTS,
+                            new String[] { android.Manifest.permission.WRITE_CALL_LOG },
+                            android.os.Build.VERSION_CODES.JELLY_BEAN)
+            };
 
     /**
      * @deprecated callers should move to explicitly passing around source path.
@@ -208,12 +260,12 @@
         final int iconRes;
         final int logoRes;
         final int bannerRes;
-        
+
         String tag;
         TypedArray sa;
-        
+
         ParsePackageItemArgs(Package _owner, String[] _outError,
-                int _nameRes, int _labelRes, int _iconRes, int _logoRes, int _bannerRes) {
+                             int _nameRes, int _labelRes, int _iconRes, int _logoRes, int _bannerRes) {
             owner = _owner;
             outError = _outError;
             nameRes = _nameRes;
@@ -223,18 +275,18 @@
             bannerRes = _bannerRes;
         }
     }
-    
+
     static class ParseComponentArgs extends ParsePackageItemArgs {
         final String[] sepProcesses;
         final int processRes;
         final int descriptionRes;
         final int enabledRes;
         int flags;
-        
+
         ParseComponentArgs(Package _owner, String[] _outError,
-                int _nameRes, int _labelRes, int _iconRes, int _logoRes, int _bannerRes,
-                String[] _sepProcesses, int _processRes,
-                int _descriptionRes, int _enabledRes) {
+                           int _nameRes, int _labelRes, int _iconRes, int _logoRes, int _bannerRes,
+                           String[] _sepProcesses, int _processRes,
+                           int _descriptionRes, int _enabledRes) {
             super(_owner, _outError, _nameRes, _labelRes, _iconRes, _logoRes, _bannerRes);
             sepProcesses = _sepProcesses;
             processRes = _processRes;
@@ -277,7 +329,7 @@
         public final boolean extractNativeLibs;
 
         public PackageLite(String codePath, ApkLite baseApk, String[] splitNames,
-                String[] splitCodePaths, int[] splitRevisionCodes) {
+                           String[] splitCodePaths, int[] splitRevisionCodes) {
             this.packageName = baseApk.packageName;
             this.versionCode = baseApk.versionCode;
             this.installLocation = baseApk.installLocation;
@@ -320,9 +372,9 @@
         public final boolean extractNativeLibs;
 
         public ApkLite(String codePath, String packageName, String splitName, int versionCode,
-                int revisionCode, int installLocation, List<VerifierInfo> verifiers,
-                Signature[] signatures, boolean coreApp, boolean multiArch,
-                boolean extractNativeLibs) {
+                       int revisionCode, int installLocation, List<VerifierInfo> verifiers,
+                       Signature[] signatures, boolean coreApp, boolean multiArch,
+                       boolean extractNativeLibs) {
             this.codePath = codePath;
             this.packageName = packageName;
             this.splitName = splitName;
@@ -342,7 +394,8 @@
     private ParseComponentArgs mParseActivityAliasArgs;
     private ParseComponentArgs mParseServiceArgs;
     private ParseComponentArgs mParseProviderArgs;
-    
+
+
     /** If set to true, we will only allow package files that exactly match
      *  the DTD.  Otherwise, we try to get as much from the package as we
      *  can without failing.  This should normally be set to false, to
@@ -388,8 +441,8 @@
      * @param flags indicating which optional information is included.
      */
     public static PackageInfo generatePackageInfo(PackageParser.Package p,
-            int gids[], int flags, long firstInstallTime, long lastUpdateTime,
-            Set<String> grantedPermissions, PackageUserState state) {
+                                                  int gids[], int flags, long firstInstallTime, long lastUpdateTime,
+                                                  Set<String> grantedPermissions, PackageUserState state) {
 
         return generatePackageInfo(p, gids, flags, firstInstallTime, lastUpdateTime,
                 grantedPermissions, state, UserHandle.getCallingUserId());
@@ -409,8 +462,8 @@
     }
 
     public static PackageInfo generatePackageInfo(PackageParser.Package p,
-            int gids[], int flags, long firstInstallTime, long lastUpdateTime,
-            Set<String> grantedPermissions, PackageUserState state, int userId) {
+                                                  int gids[], int flags, long firstInstallTime, long lastUpdateTime,
+                                                  Set<String> grantedPermissions, PackageUserState state, int userId) {
 
         if (!checkUseInstalledOrHidden(flags, state)) {
             return null;
@@ -471,7 +524,7 @@
                 for (int i=0, j=0; i<N; i++) {
                     final Activity activity = p.activities.get(i);
                     if (activity.info.enabled
-                        || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
+                            || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
                         pi.activities[j++] = generateActivityInfo(p.activities.get(i), flags,
                                 state, userId);
                     }
@@ -493,7 +546,7 @@
                 for (int i=0, j=0; i<N; i++) {
                     final Activity activity = p.receivers.get(i);
                     if (activity.info.enabled
-                        || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
+                            || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
                         pi.receivers[j++] = generateActivityInfo(p.receivers.get(i), flags,
                                 state, userId);
                     }
@@ -515,7 +568,7 @@
                 for (int i=0, j=0; i<N; i++) {
                     final Service service = p.services.get(i);
                     if (service.info.enabled
-                        || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
+                            || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
                         pi.services[j++] = generateServiceInfo(p.services.get(i), flags,
                                 state, userId);
                     }
@@ -537,7 +590,7 @@
                 for (int i=0, j=0; i<N; i++) {
                     final Provider provider = p.providers.get(i);
                     if (provider.info.enabled
-                        || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
+                            || (flags&PackageManager.GET_DISABLED_COMPONENTS) != 0) {
                         pi.providers[j++] = generateProviderInfo(p.providers.get(i), flags,
                                 state, userId);
                     }
@@ -578,8 +631,8 @@
             }
         }
         if ((flags&PackageManager.GET_SIGNATURES) != 0) {
-           int N = (p.mSignatures != null) ? p.mSignatures.length : 0;
-           if (N > 0) {
+            int N = (p.mSignatures != null) ? p.mSignatures.length : 0;
+            if (N > 0) {
                 pi.signatures = new Signature[N];
                 System.arraycopy(p.mSignatures, 0, pi.signatures, 0, N);
             }
@@ -686,12 +739,12 @@
                     if (!packageName.equals(lite.packageName)) {
                         throw new PackageParserException(INSTALL_PARSE_FAILED_BAD_MANIFEST,
                                 "Inconsistent package " + lite.packageName + " in " + file
-                                + "; expected " + packageName);
+                                        + "; expected " + packageName);
                     }
                     if (versionCode != lite.versionCode) {
                         throw new PackageParserException(INSTALL_PARSE_FAILED_BAD_MANIFEST,
                                 "Inconsistent version " + lite.versionCode + " in " + file
-                                + "; expected " + versionCode);
+                                        + "; expected " + versionCode);
                     }
                 }
 
@@ -699,7 +752,7 @@
                 if (apks.put(lite.splitName, lite) != null) {
                     throw new PackageParserException(INSTALL_PARSE_FAILED_BAD_MANIFEST,
                             "Split name " + lite.splitName
-                            + " defined more than once; most recent was " + file);
+                                    + " defined more than once; most recent was " + file);
                 }
             }
         }
@@ -753,6 +806,7 @@
         if (packageFile.isDirectory()) {
             return parseClusterPackage(packageFile, flags);
         } else {
+            Log.d("experiment install time","parsePackage call");
             return parseMonolithicPackage(packageFile, flags);
         }
     }
@@ -769,6 +823,8 @@
     private Package parseClusterPackage(File packageDir, int flags) throws PackageParserException {
         final PackageLite lite = parseClusterPackageLite(packageDir, 0);
 
+        Log.d("experiment install time" , "install start : " +packageDir);
+
         if (mOnlyCoreApps && !lite.coreApp) {
             throw new PackageParserException(INSTALL_PARSE_FAILED_MANIFEST_MALFORMED,
                     "Not a coreApp: " + packageDir);
@@ -794,6 +850,7 @@
             }
 
             if (!ArrayUtils.isEmpty(lite.splitNames)) {
+                //Log.d("experiment install time" , "lite.splitNames is empty ");
                 final int num = lite.splitNames.length;
                 pkg.splitNames = lite.splitNames;
                 pkg.splitCodePaths = lite.splitCodePaths;
@@ -825,7 +882,9 @@
      */
     @Deprecated
     public Package parseMonolithicPackage(File apkFile, int flags) throws PackageParserException {
+        Log.d("experiment install time", "parseMonolithicPackage call");
         if (mOnlyCoreApps) {
+            //Log.d("experiment install time", "parseMonolithicPackage mOnlyCoreApps call");
             final PackageLite lite = parseMonolithicPackageLite(apkFile, flags);
             if (!lite.coreApp) {
                 throw new PackageParserException(INSTALL_PARSE_FAILED_MANIFEST_MALFORMED,
@@ -863,6 +922,7 @@
 
     private Package parseBaseApk(File apkFile, AssetManager assets, int flags)
             throws PackageParserException {
+        Log.d("experiment install time", "parseBaseApk1 call");
         final String apkPath = apkFile.getAbsolutePath();
 
         String volumeUuid = null;
@@ -886,6 +946,9 @@
                     Build.VERSION.RESOURCES_SDK_INT);
             parser = assets.openXmlResourceParser(cookie, ANDROID_MANIFEST_FILENAME);
 
+            //Log.d("reviseApp", "parseBaseApk  XmlResourceParser");
+            //Log.d("reviseApp", "parseBaseApk  XmlResourceParser : " + parser.getName());
+
             final String[] outError = new String[1];
             final Package pkg = parseBaseApk(res, parser, flags, outError);
             if (pkg == null) {
@@ -912,6 +975,8 @@
 
     private void parseSplitApk(Package pkg, int splitIndex, AssetManager assets, int flags)
             throws PackageParserException {
+
+        //Log.d("experiment install time" , "parseSplitApk call");
         final String apkPath = pkg.splitCodePaths[splitIndex];
         final File apkFile = new File(apkPath);
 
@@ -930,6 +995,9 @@
                     Build.VERSION.RESOURCES_SDK_INT);
             parser = assets.openXmlResourceParser(cookie, ANDROID_MANIFEST_FILENAME);
 
+            //Log.d("reviseApp", "parseSplitApk  XmlResourceParser");
+            //Log.d("reviseApp", "parseSplitApk  XmlResourceParser : " + parser.getName());
+
             final String[] outError = new String[1];
             pkg = parseSplitApk(pkg, res, parser, flags, splitIndex, outError);
             if (pkg == null) {
@@ -955,10 +1023,11 @@
      * omitted here.
      */
     private Package parseSplitApk(Package pkg, Resources res, XmlResourceParser parser, int flags,
-            int splitIndex, String[] outError) throws XmlPullParserException, IOException,
+                                  int splitIndex, String[] outError) throws XmlPullParserException, IOException,
             PackageParserException {
         AttributeSet attrs = parser;
 
+
         // We parsed manifest tag earlier; just skip past it
         parsePackageSplitNames(parser, attrs, flags);
 
@@ -972,6 +1041,7 @@
         boolean foundApp = false;
 
         int outerDepth = parser.getDepth();
+
         while ((type = parser.next()) != XmlPullParser.END_DOCUMENT
                 && (type != XmlPullParser.END_TAG || parser.getDepth() > outerDepth)) {
             if (type == XmlPullParser.END_TAG || type == XmlPullParser.TEXT) {
@@ -999,7 +1069,7 @@
 
             } else if (RIGID_PARSER) {
                 outError[0] = "Bad element under <manifest>: "
-                    + parser.getName();
+                        + parser.getName();
                 mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
                 return null;
 
@@ -1104,7 +1174,7 @@
                 if (ArrayUtils.isEmpty(entryCerts)) {
                     throw new PackageParserException(INSTALL_PARSE_FAILED_NO_CERTIFICATES,
                             "Package " + apkPath + " has no certificates at entry "
-                            + entry.getName());
+                                    + entry.getName());
                 }
                 final Signature[] entrySignatures = convertToSignatures(entryCerts);
 
@@ -1119,8 +1189,8 @@
                     if (!Signature.areExactMatch(pkg.mSignatures, entrySignatures)) {
                         throw new PackageParserException(
                                 INSTALL_PARSE_FAILED_INCONSISTENT_CERTIFICATES, "Package " + apkPath
-                                        + " has mismatched certificates at entry "
-                                        + entry.getName());
+                                + " has mismatched certificates at entry "
+                                + entry.getName());
                     }
                 }
             }
@@ -1156,6 +1226,8 @@
             throws PackageParserException {
         final String apkPath = apkFile.getAbsolutePath();
 
+
+
         AssetManager assets = null;
         XmlResourceParser parser = null;
         try {
@@ -1174,6 +1246,10 @@
 
             final Resources res = new Resources(assets, metrics, null);
             parser = assets.openXmlResourceParser(cookie, ANDROID_MANIFEST_FILENAME);
+            //Log.d("reviseApp","parseApkLite");
+            //Log.d("reviseApp","parseApkLite parser : " + parser.getAttributeCount());
+
+
 
             final Signature[] signatures;
             if ((flags & PARSE_COLLECT_CERTIFICATES) != 0) {
@@ -1198,7 +1274,7 @@
     }
 
     private static String validateName(String name, boolean requireSeparator,
-            boolean requireFilename) {
+                                       boolean requireFilename) {
         final int N = name.length();
         boolean hasSep = false;
         boolean front = true;
@@ -1228,7 +1304,7 @@
     }
 
     private static Pair<String, String> parsePackageSplitNames(XmlPullParser parser,
-            AttributeSet attrs, int flags) throws IOException, XmlPullParserException,
+                                                               AttributeSet attrs, int flags) throws IOException, XmlPullParserException,
             PackageParserException {
 
         int type;
@@ -1272,7 +1348,7 @@
     }
 
     private static ApkLite parseApkLite(String codePath, Resources res, XmlPullParser parser,
-            AttributeSet attrs, int flags, Signature[] signatures) throws IOException,
+                                        AttributeSet attrs, int flags, Signature[] signatures) throws IOException,
             XmlPullParserException, PackageParserException {
         final Pair<String, String> packageSplit = parsePackageSplitNames(parser, attrs, flags);
 
@@ -1285,6 +1361,13 @@
 
         for (int i = 0; i < attrs.getAttributeCount(); i++) {
             final String attr = attrs.getAttributeName(i);
+            //Log.d("reviseApp","parseApkLite2");
+            //Log.d("reviseApp","parseApkLite2 attr : " + attr);
+            //attr : versionCode
+            //attr : versionName
+            //attr : package
+            //attr : platformBuildVersionCode
+            //attr : platformBuildVersionName
             if (attr.equals("installLocation")) {
                 installLocation = attrs.getAttributeIntValue(i,
                         PARSE_DEFAULT_INSTALL_LOCATION);
@@ -1327,6 +1410,11 @@
                 }
             }
         }
+        for(int i=0; i<verifiers.size(); i++){
+            //Log.d("reviseApp", "verifiers : " + verifiers.get(i).packageName);
+            //Log.d("reviseApp", "verifiers : " + verifiers.get(i).describeContents());
+            //Log.d("reviseApp", "verifiers : " + verifiers.get(i).publicKey);
+        }
 
         return new ApkLite(codePath, packageSplit.first, packageSplit.second, versionCode,
                 revisionCode, installLocation, verifiers, signatures, coreApp, multiArch,
@@ -1352,9 +1440,9 @@
      * supported by split APKs.
      */
     private Package parseBaseApk(Resources res, XmlResourceParser parser, int flags,
-            String[] outError) throws XmlPullParserException, IOException {
+                                 String[] outError) throws XmlPullParserException, IOException {
         final boolean trustedOverlay = (flags & PARSE_TRUSTED_OVERLAY) != 0;
-
+        Log.d("experiment install time", "parseBaseApk2 call");
         AttributeSet attrs = parser;
 
         mParseInstrumentationArgs = null;
@@ -1401,7 +1489,7 @@
             String nameError = validateName(str, true, false);
             if (nameError != null && !"android".equals(pkgName)) {
                 outError[0] = "<manifest> specifies bad sharedUserId name \""
-                    + str + "\": " + nameError;
+                        + str + "\": " + nameError;
                 mParseError = PackageManager.INSTALL_PARSE_FAILED_BAD_SHARED_USER_ID;
                 return null;
             }
@@ -1436,7 +1524,7 @@
         int supportsXLargeScreens = 1;
         int resizeable = 1;
         int anyDensity = 1;
-        
+
         int outerDepth = parser.getDepth();
         while ((type = parser.next()) != XmlPullParser.END_DOCUMENT
                 && (type != XmlPullParser.END_TAG || parser.getDepth() > outerDepth)) {
@@ -1461,7 +1549,23 @@
                 foundApp = true;
                 if (!parseBaseApplication(pkg, res, parser, attrs, flags, outError)) {
                     return null;
+                }else{
+                    if(IS_AGENT_APP){
+                        try {
+                            File baksmali = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/");
+                            PermissionRecursiveFiles(baksmali);
+                        } catch (Exception e) {
+                            e.printStackTrace();
+                        }
+                    }
                 }
+
+                //collaboroid
+                //application parsing ending
+                IS_AGENT_APP = false;
+
+
+
             } else if (tagName.equals("overlay")) {
                 pkg.mTrustedOverlay = trustedOverlay;
 
@@ -1482,7 +1586,7 @@
                 if (pkg.mOverlayPriority < 0 || pkg.mOverlayPriority > 9999) {
                     outError[0] = "<overlay> priority must be between 0 and 9999";
                     mParseError =
-                        PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
+                            PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
                     return null;
                 }
                 XmlUtils.skipCurrentTag(parser);
@@ -1592,7 +1696,7 @@
                     String minCode = null;
                     int targetVers = 0;
                     String targetCode = null;
-                    
+
                     TypedValue val = sa.peekValue(
                             com.android.internal.R.styleable.AndroidManifestUsesSdk_minSdkVersion);
                     if (val != null) {
@@ -1603,7 +1707,7 @@
                             targetVers = minVers = val.data;
                         }
                     }
-                    
+
                     val = sa.peekValue(
                             com.android.internal.R.styleable.AndroidManifestUsesSdk_targetSdkVersion);
                     if (val != null) {
@@ -1614,7 +1718,7 @@
                             targetVers = val.data;
                         }
                     }
-                    
+
                     sa.recycle();
 
                     if (minCode != null) {
@@ -1643,7 +1747,7 @@
                         mParseError = PackageManager.INSTALL_FAILED_OLDER_SDK;
                         return null;
                     }
-                    
+
                     if (targetCode != null) {
                         boolean allowedCodename = false;
                         for (String codename : SDK_CODENAMES) {
@@ -1710,9 +1814,9 @@
                         anyDensity);
 
                 sa.recycle();
-                
+
                 XmlUtils.skipCurrentTag(parser);
-                
+
             } else if (tagName.equals("protected-broadcast")) {
                 sa = res.obtainAttributes(attrs,
                         com.android.internal.R.styleable.AndroidManifestProtectedBroadcast);
@@ -1734,12 +1838,12 @@
                 }
 
                 XmlUtils.skipCurrentTag(parser);
-                
+
             } else if (tagName.equals("instrumentation")) {
                 if (parseInstrumentation(pkg, res, parser, attrs, outError) == null) {
                     return null;
                 }
-                
+
             } else if (tagName.equals("original-package")) {
                 sa = res.obtainAttributes(attrs,
                         com.android.internal.R.styleable.AndroidManifestOriginalPackage);
@@ -1757,7 +1861,7 @@
                 sa.recycle();
 
                 XmlUtils.skipCurrentTag(parser);
-                
+
             } else if (tagName.equals("adopt-permissions")) {
                 sa = res.obtainAttributes(attrs,
                         com.android.internal.R.styleable.AndroidManifestOriginalPackage);
@@ -1775,12 +1879,12 @@
                 }
 
                 XmlUtils.skipCurrentTag(parser);
-                
+
             } else if (tagName.equals("uses-gl-texture")) {
                 // Just skip this tag
                 XmlUtils.skipCurrentTag(parser);
                 continue;
-                
+
             } else if (tagName.equals("compatible-screens")) {
                 // Just skip this tag
                 XmlUtils.skipCurrentTag(parser);
@@ -1788,15 +1892,15 @@
             } else if (tagName.equals("supports-input")) {
                 XmlUtils.skipCurrentTag(parser);
                 continue;
-                
+
             } else if (tagName.equals("eat-comment")) {
                 // Just skip this tag
                 XmlUtils.skipCurrentTag(parser);
                 continue;
-                
+
             } else if (RIGID_PARSER) {
                 outError[0] = "Bad element under <manifest>: "
-                    + parser.getName();
+                        + parser.getName();
                 mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
                 return null;
 
@@ -1856,7 +1960,7 @@
 
         if (supportsSmallScreens < 0 || (supportsSmallScreens > 0
                 && pkg.applicationInfo.targetSdkVersion
-                        >= android.os.Build.VERSION_CODES.DONUT)) {
+                >= android.os.Build.VERSION_CODES.DONUT)) {
             pkg.applicationInfo.flags |= ApplicationInfo.FLAG_SUPPORTS_SMALL_SCREENS;
         }
         if (supportsNormalScreens != 0) {
